/**
* Copyright 2016 BitTorrent Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
#include "../gtest.h"
#include "TestLogger.h"

#include <scraps/log/FilterLogger.h>

using namespace std::literals;

TEST(FilterLogger, basicUsage) {
    auto dest = std::make_shared<TestLogger>();
    scraps::log::FilterLogger filter{dest, [](scraps::log::Level level, auto...){ return level == scraps::log::Level::kDebug; }};

    filter.log({scraps::log::Level::kDebug, "bar.c", 2, "bar"});
    EXPECT_EQ(dest->messages.size(), 1);
    EXPECT_EQ(dest->messages.back(), "DEBUG bar.c:2 bar");
    filter.log({scraps::log::Level::kError, "bar.c", 2, "bar"});
    EXPECT_EQ(dest->messages.size(), 1);
}
